#include <cctype>
#include <cerrno>
#include <csignal>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

/*
    
    This program talks http with stdin and stdout.

*/

#include "config.hh"
#include "logfun.h"
#include "radiofun.hh"

static void Strup(string &s)
{
    unsigned a;
    for(a=0; a<s.size(); ++a)s[a]=toupper(s[a]);
}
/* lukee rivin sytteest */
static const string Gets(unsigned timeout = 0)
{
    for(;;)
    {
        if(timeout)
        {
            fd_set fds;
            struct timeval tv = {timeout, 0};
            FD_ZERO(&fds);
            FD_SET(0, &fds);
            //fprintf(stderr, "selektaillaan %u sekuntia\n", timeout);
            if(!select(1, &fds, NULL, NULL, &tv))
            {
                //fprintf(stderr, "timeout\n");
                return "";
            }
            //fprintf(stderr, "selektailtu\n");
            timeout -= tv.tv_sec;
        }
        char Buf[4096];
        if(!fgets(Buf, sizeof Buf, stdin))throw 2;
        string s = Buf;
        {std::string::size_type a = s.find("\r"); if(a != s.npos)s.erase(a);}
        {std::string::size_type a = s.find("\n"); if(a != s.npos)s.erase(a);}
        //fprintf(stderr, "Got '%s'\n", s.c_str());
        return s;
    }
}

static void PHPdump(const string &fn, const string &args="")
#ifdef __GNUC__
__attribute__ ((noreturn));
static void PHPdump(const string &fn, const string &args)
#endif
{
    fflush(stdout);
    /* Don't fork. We are really exitting after this! */
    chdir(Configuration.GetString("phpdirectory").c_str());
    
    execlp("php", "php", fn.c_str(), ("tmp=1&"+args).c_str(), NULL);
    perror("php");
    printf("\r\n\n\nInternal error: php not found\n");
    exit(errno);
}

int main(int argc, const char *const *argv)
{
    bool full = false;
    for(int a=1; a<argc; ++a)
    {
        string s = argv[a];
        if(s == "-f")full = true;
    }
    
    setbuf(stdin, NULL); /* Or else select() will not work */
    
    string s = Gets(60);
    Strup(s);
    
    DumpTime();
    fprintf(stderr, "HTTP query: '%s'\n", s.c_str());
    
    if(s.substr(0, 4) != "GET ")
    {
        printf("߂Ղӓ{\r\n"); /* emme puhu Nihongoa */
        return 0;
    }
    s.erase(0, 4);
    {std::string::size_type a = s.find(" HTTP/1."); if(a != s.npos)s.erase(a);}
    
    if(s != "/"
    && s != "/ROBOTS.TXT"
    && s != "/LISTEN.PLS")
    {
        printf("HTTP/1.0 404 Object not found\r\n");
        PHPdump("notfound.php", "error="+s); /* doesn't return */
    }
    string Agent;
    string Host;
    for(;;)
    {
        string s = Gets(2);
        Strup(s);
        std::string::size_type a = s.find(':');
        if(a == s.npos)break;
        string Header = s.substr(0, a);
        while(++a < s.size() && s[a]==' ');
        string Content = s.substr(a);
        
        if(Header == "HOST")Host = Content;
        else if(Header == "USER-AGENT")Agent = Content;
    }
    if(s == "/ROBOTS.TXT")
    {
        printf("HTTP/1.0 200 As-you-wish\r\n"
               "Content-Type: text/plain\r\n"
               "\r\n"
               "User-agent: *\r\n"
               "Disallow: /\r\n");
        return 0;
    }    
    if(s == "/LISTEN.PLS")
    {
        printf("HTTP/1.0 200 OK\r\n");
        string args = "host=" + Host;
        if(full)args += "&full=1";
        args += "&version="VERSION;
        args += "&ports="+Configuration.GetString("listen");
        PHPdump("playlist.php", args); /* doesn't return */
    }
    if(Agent.find("LYNX") == 0
    || Agent.find("LINKS") == 0
    || Agent.find("MOZILLA") != Agent.npos)
    {
        printf("HTTP/1.0 200 OK\r\n");
        PHPdump("index.php", full ? "full=1" : "full=0"); /* doesn't return */
    }
    if(full)
    {
        printf("HTTP/1.0 507 Server is full\r\n");
        PHPdump("full.php"); /* doesn't return */
    }
    
    printf(
        "HTTP/1.0 200 OK\r\n"
        "Content-type: audio/mp3\r\n"
        "icy-notice1: %s\r\n"
        "icy-notice2: %s\r\n"
        "icy-name: %s\r\n"
        "icy-genre: %s\r\n"
        "icy-url: %s\r\n"
        "icy-pub: 1\r\n"
        "icy-br: %d\r\n"
        "\r\n",
        Configuration.GetString("icynotice1").c_str(),
        Configuration.GetString("icynotice2").c_str(),
        Configuration.GetString("name").c_str(),
        Configuration.GetString("genre").c_str(),
        Configuration.GetString("url").c_str(),
        Configuration.GetInteger("kbrate")
    );
    return LISTENER_RETURN_STATUS; /* Stream! */
}
