#include <cstdlib>
#include <cctype>
#include <cmath>

#include <string>
#include <map>

using namespace std;

#include "v6.h"
#include "chrtab.h"

#define MAX 50

static void add(string &s, int &o, int &vo, int a, float v)
{
	while(o > a/12)
	{
		s += '<';
		o--;
	}
	while(o < a/12)
	{
		s += '>';
		o++;
	}
	int V(int(v*64));
	
	if(V != vo)
	{
		char Buf[4];
		sprintf(Buf, "V%d", vo=V);
		s += Buf;
	}
	
	switch(a%12)
	{
		case 0: s += 'c';  break;
		case 1: s += "c+"; break;
		case 2: s += 'd';  break;
		case 3: s += "d+"; break;
		case 4: s += 'e';  break;
		case 5: s += 'f';  break;
		case 6: s += "f+"; break;
		case 7: s += 'g';  break;
		case 8: s += "g+"; break;
		case 9: s += 'a';  break;
		case 10:s += "a+"; break;
		case 11:s += 'b';  break;
	}
}
	
static int Scales[V6_COLS];

static string s[MAX];
static int o[MAX];
static int v[MAX];

static void Init()
{
	int a;
	MkTab();
	
	for(a=0; a<MAX; a++)
	{
		s[a]="";
		o[a]=2;
		v[a]=32;
	}
	
	float p = V6_MINHERZ;
	
	for(a=0; a < V6_COLS; a++)
	{
		Scales[a] = int(V6_HZPOS(p));
		
		p *= V6_NUMBASE;
		p += V6_ADD;
	}
	SetAttr(7);
	FlushSetAttr();		
	printf("\33(U");
}

static void Done()
{
	printf("\33(B\n\n");
	
	printf("mst70l1v32{");
	
	for(int a=0; a<MAX; a++)
		printf("%s,", s[a].c_str());
		
	printf("}\n");
}

static void View()
{
	int a, ch, ednyt=Scales[0];
	static float Res[V6_COLS];
	float Res2[V6_COLS];	
	bool dih[V6_COLS];

	static int steppi=0;
	if(!steppi)memset(Res, 0, sizeof Res);

	for(a=0; a<V6_COLS; a++)
	{
		register int dy=0, nyt = Scales[a];
		float temp = 0;
		
		if(nyt>ednyt)ednyt++;
		for(ch=ednyt; ch<=nyt; ch++)
		{
			dy++;
			temp += Power[ch]; // - Avg[ch]/AvgCount;
		}
		temp /= dy;
		temp = temp<0 ? 0 : sqrt(temp);
		Res[a] += temp;
		ednyt = nyt;
	}
	
	steppi = !steppi;
	if(steppi)return;

	map<float,int> levels;
	
	for(a=0; a<V6_COLS; a++)
	{
		float temp=Res[a], Temp;
//		float lt=a>0         ?Res[a-1]:0;
//		float rt=a<V6_COLS-1 ?Res[a+1]:0;
//		float lt2=a>1         ?Res[a-2]:0;
//		float rt2=a<V6_COLS-2 ?Res[a+2]:0;
		
		Temp = temp/8;
		// (temp<lt || temp<rt) ? temp/2 : temp;
			
	//	Temp -= 0.2;
		
		if(Temp > 1)Temp = 1;	
	//	if(Temp < 0)Temp = 0;
		
	//	if(temp<rt || temp<=lt || temp<rt2 || temp<=lt2)Temp=0;
		
		Res2[a]=Temp;
		levels[Temp] = a;
		dih[a] = false;
	}
	
	int k=0;
	map<float,int>::reverse_iterator i;
	for(i=levels.rbegin(); i!=levels.rend(); i++)
	{
		//printf("%.3f\n", i->first);
		if(k++ < MAX)dih[i->second] = true;
	}	
	k=0;
	putchar('|');
	for(a=0; a<V6_COLS; a++)
	{		
		float temp = Res2[a];
		
		if(!dih[a])
			temp = 0;
		else if(k<MAX)
		{
			add(s[k], o[k], v[k], a, temp);
			k++;
		}
	#if 1
		int R=int((rmax-1)*temp);
		int G=int((gmax-1)*temp);
		int B=int((bmax-1)*temp);
		
     	SetAttr(Lookup[R][G][B] >> 8);
		FlushSetAttr();
		
		putchar(Lookup[R][G][B] & 255);
	#else
		putchar('A' + int(temp*25));
	#endif
	}
		
	SetAttr(7);
	FlushSetAttr();	
	
	putchar('|');
	
	SetAttr(7);
	FlushSetAttr();
	
	puts("");
}

Viewer V6 = {fb_not_required, 0, Init, Done, View};
